# Fraga 22/09/2017
# Fraga  3/04/2019
import mol

Swarm = mol.MOL()

# Arguments:
# Swarm size
# Number of generations
# Number of variables
# omega
# phi_g

# Para encontrar el mínimo de la función esférica con 4 variables:
Swarm.SetParameters( 16, 30, 1, -0.3328, 2.8446 )
Swarm.SetLimits( [0.0], [7.0] )

Swarm.InitializeParticles( ) 
Swarm.EvaluateParticles( ) 
Swarm.InitializeVelocities( )

i=0
while i<Swarm._gen :
	j=0
	while j < Swarm._tamanio :
		Swarm.NewVelocities( j )

		Swarm.NewPositions( j ) 

		Swarm.EvaluateOneParticle( j ) 

		j += 1

	i += 1


Swarm.PrintBest()

# for each particle i = 1, ..., S do
#    Initialize the particle's position with a uniformly distributed random vector: xi ~ U(blo, bup)
#    Initialize the particle's best known position to its initial position: pi ← xi
#    if f(pi) < f(g) then
#        update the swarm's best known  position: g ← pi
#    Initialize the particle's velocity: vi ~ U(-|bup-blo|, |bup-blo|)
# while a termination criterion is not met do:
#    for each particle i = 1, ..., S do
#       for each dimension d = 1, ..., n do
#          Pick random numbers: rp, rg ~ U(0,1)
#          Update the particle's velocity: vi,d ← ω vi,d + φp rp (pi,d-xi,d) + φg rg (gd-xi,d)
#       Update the particle's position: xi ← xi + vi
#       if f(xi) < f(pi) then
#          Update the particle's best known position: pi ← xi
#          if f(pi) < f(g) then
#             Update the swarm's best known position: g ← pi
