# The function f
# This is a script for gnuplot program
# Runing it as:
# gnuplot f.gnu
#

f(x) = (x-2)*(x-5) + sin( 1.5*pi*x )
#      x^2 - 7x + 10 + sin( 1.5*pi*x )

df(x) = 2.0*x - 7.0 + 1.5*pi * cos( 1.5*pi*x ) 
set xrange [0:7]
set yrange [-11:11]
set grid

plot f(x), df(x)
pause -1
