# encoding: utf8
import sys
import math
#
# The newton method to find the roots of a function
# Fraga 18.03.2020

n = len( sys.argv )
if n != 2 :
	print( "Args: inicial_value" )
	sys.exit(1)

x = float( sys.argv[1] )

def f1(x):
	v = (x-2.0)*(x-5.0) + math.sin( 1.5*math.pi*x )
	return v

def df1(x):
	v = 2.0*x - 7.0 + 1.5*math.pi * math.cos( 1.5*math.pi*x )
	return v

def ddf1(x):
	v = 2.0 - 1.5*math.pi*1.5*math.pi * math.sin( 1.5*math.pi*x )
	return v

# print( "0", x )
i = 1
while i < 20 :  # 20 maximum iterations
	Deltaa = -df1(x)/ddf1(x)
	x += Deltaa

	# print( i, x )

	if abs(Deltaa) < 1e-10 :
		break

	i += 1

print( x )
